/*
 * $Id: vimage.h,v 1.3 1995/07/30 19:20:47 traister Exp traister $
 * vimage.h: typdefs & prototypes for vimage.c, an SVGA picture viewer
 *           for Linux
 * Copyright (c) 1995, Joe Traister
 * 
 * $Log: vimage.h,v $
 * Revision 1.3  1995/07/30  19:20:47  traister
 * Updated copyright prior to first public release
 *
 * Revision 1.2  1995/05/13  22:40:17  traister
 * Added "break" in slide show when ESC hit.
 *
 * Revision 1.1  1995/05/13  01:41:04  traister
 * Initial revision
 *
*/
/*   This program is free software; you can redistribute it and/or
     modify it under the terms of the GNU General Public License
     as published by the Free Software Foundation; either version 2
     of the License, or (at your option) any later version.

     This program is distributed in the hope that it will be useful,
     but WITHOUT ANY WARRANTY; without even the implied warranty of
     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
     GNU General Public License for more details.

     You should have received a copy of the GNU General Public License
     along with this program; if not, write to the Free Software
     Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. */

#include <stdio.h>
#include <unistd.h>

#define UCHAR		unsigned char
#define USHORT		unsigned short

typedef struct image_tag {
  int width, height, palsize;
  UCHAR *bits;
  int palette[256];
} IMAGE;

#ifdef JPEG_SUPPORT
enum { GIF=1, PNM, SUN, TARGA, JPEG };
#else
enum { GIF=1, PNM, SUN, TARGA };
#endif

extern int quiet, automode, twopass, floyd, pictime, timer;
extern char modename[];

int DisplayImage(IMAGE*, char*);
int GetFileHead(FILE*, IMAGE*, char*);
int ReadPNMHead(FILE*, IMAGE*);
int ReadPNM(FILE*, IMAGE*);
int ReadGIFHead(FILE*, IMAGE*);
int ReadGIF(FILE*, IMAGE*);
int ReadRasterfileHead(FILE*, IMAGE*);
int ReadRasterfile(FILE*, IMAGE*);
int ReadTargaHead(FILE*, IMAGE*);
int ReadTarga(FILE*, IMAGE*);
void Error(char*, char*);
void InitVGA(char *);
int MapToCube(IMAGE *);
int HeckbertMedianCut(IMAGE *);
void VGAShutdown(void);
void SetID(void);
void Slideshow(char **, int);

#ifdef JPEG_SUPPORT
int ReadJPEGHead(FILE*, IMAGE*);
int ReadJPEG(FILE*, IMAGE*);
#endif

#ifdef NCURSES_SUPPORT
int fileSelector(char **, int);
void CursesShutdown();
#endif
